#! /usr/bin/perl -wT

use strict ;

$main::WIKI_ROOT = "/srv/www/urchin.earth.li/users/twic/wiki/" ;
our $WIKI_ROOT ;
$main::WIKI_EXT = ".twici" ;
our $WIKI_EXT ;
$main::WIKI_BASE = "http://urchin.earth.li/cgi-bin/twic/wiki/" ;
our $WIKI_BASE ;
$main::WIKI_VIEW_BASE = $WIKI_BASE . "view.pl?page=" ;
our $WIKI_VIEW_BASE ;
$main::WIKI_EDIT_BASE = $WIKI_BASE . "edit.pl?page=" ;
our $WIKI_EDIT_BASE ;
$main::WIKI_SOURCE_BASE = $WIKI_BASE . "source.pl?page=" ;
our $WIKI_SOURCE_BASE ;
$main::WIKI_BACKLINKS_BASE = $WIKI_BASE . "backlinks.pl?page=" ;
our $WIKI_BACKLINKS_BASE ;
$main::WIKI_CHANGES_ACTION = $WIKI_BASE . "changes.pl" ;
# could have a WIKI_CHANGES_BASE which is this + "?days="
$main::WIKI_NAME_RE = "([A-Z][0-9a-z]*[A-Z][0-9a-zA-Z]*)" ;
our $WIKI_NAME_RE ;
$main::BARE_WIKI_NAME_RE = "^$WIKI_NAME_RE\$" ;
our $BARE_WIKI_NAME_RE ;
$main::EMBEDDED_WIKI_NAME_RE = "^([^0-9a-zA-z]*)$WIKI_NAME_RE([^0-9a-zA-z]*)\$" ;
our $EMBEDDED_WIKI_NAME_RE ;
$main::WIKI_PAGE_FILENAME_RE = "^$WIKI_NAME_RE$WIKI_EXT\$" ;
$main::URL_RE = "([a-zA-Z][0-9a-zA-Z+\-\.]*:.+)" ;
our $URL_RE ;
$main::EMBEDDED_URL_RE = "^([^0-9a-zA-z]*)$URL_RE([^0-9a-zA-z]*)\$" ;
$main::FRONT_PAGE = "FrontPage" ;
our $FRONT_PAGE ;
$main::CHANGES_PAGE = "RecentChanges" ;
our $CHANGES_PAGE ;
$main::MOTD_PAGE = "MessageOfTheDay" ;
our $MOTD_PAGE ;
@main::KEY_PAGES = ($FRONT_PAGE, $CHANGES_PAGE, $MOTD_PAGE) ;
$main::SECS_PER_DAY = 24 * 60 * 60 ;
$main::DOCTYPE = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">" ;
# $main::META_CHARSET = "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=ISO-8859-1\"> " ;

sub exists
{
	my $name = shift @_ ;
	my $file = pageFile( $name ) ;
	return -e $file ;
}

sub pageFile
{
	my $page = shift @_ ;
	return $WIKI_ROOT . $page . $WIKI_EXT ;
}

sub viewUrl
{
	my $page = shift @_ ;
	return $WIKI_VIEW_BASE . $page ;
}

sub editUrl
{
	my $page = shift @_ ;
	return $WIKI_EDIT_BASE . $page ;
}

sub sourceUrl
{
	my $page = shift @_ ;
	return $WIKI_SOURCE_BASE . $page ;
}

sub backlinksUrl
{
        my $page = shift @_ ;
        return $WIKI_BACKLINKS_BASE . $page ;
}

sub validateUrl
{
	my $page = shift @_ ;
	my $viewUrl = &viewUrl( $page ) ;
	return "http://validator.w3.org/check?uri=" . $viewUrl ;
}

sub cleanPage
{
	my $page = shift @_ ;
	$page =~ /$BARE_WIKI_NAME_RE/ || die( "bad page name: $page" ) ;
	$page = $1 ;
	return $page ;
}

sub normaliseLines
{
	my $text = shift @_ ;
	return join( "\n", split( /\x0D\x0A|\x0A|\x0D/, $text ) ) . "\n" ;
#	$text =~ s/\x0D\x0A|\x0A|\x0D/\n/ ;
		# why doesn't this work?
	return $text ;
}

sub parse
{
	my $queryString = shift @_ ;
	my @pairs = split( "&", $queryString ) ;
	my %query ;
	foreach my $pair (@pairs)
	{
	        (my $name, my $value) = split( "=", $pair ) ;
		defined( $value ) || die( "bad pair: $pair" ) ;
	        $value =~ tr/+/ / ;
	        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg ;
	        $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg ;
	        $value =~ s/\0//g ;
	        $name  =~ s/\0//g ;
	        $query{$name} = $value ;
	}
	return %query ;
}

sub mtime
{
	my $file = shift @_ ;
	my @stat = stat( $file ) ;
	return $stat[9] ;
}

sub pageMtime
{
	my $page = shift @_ ;
	my $file = $WIKI_ROOT . $page . $WIKI_EXT ;
	return &mtime( $file ) ;
}
